#include <iostream>

using namespace std;

void pkln(int a[],bool b[],int q){
    if(q==0) return;
    else{
        int l,d,p=0;
        cin>>l>>d;
        for(int j=l;j<d;j++)
            if(a[j]<a[j-1]){
                if(p==1){
                    pkln(a,b,q-1);
                    b[q-1]=false;
                    p=2;}
                else p=1;
                }
        if(p!=2){
            pkln(a,b,q-1);
            b[q-1]=true;
        }
    }
}
int main()
{   int n,q;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++)
        cin>>a[i];
    cin>>q;
    bool b[q];
    pkln(a,b,q);
    for (int i=q-1;i>-1;i--)
        if(b[i])
            cout<<"DA"<<endl;
        else
            cout<<"NE"<<endl;
    return 0;
}